package fishrungames.bashgid;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Locale;

import fishrungames.bashgid.core.AlbumManager;

import fishrungames.bashgid.core.AlbumManager.AlbumRecordData;
import fishrungames.bashgid.core.AlbumManager.AlbumShortData;
import fishrungames.bashgid.core.ArticleManager;

import fishrungames.bashgid.core.ArticleManager.ArticleRecordData;
import fishrungames.bashgid.core.BookManager.BookRecord;

import fishrungames.bashgid.core.AlbumManager.AlbumFullData;
import fishrungames.bashgid.core.ArticleManager.ArticleFullData;
import fishrungames.bashgid.core.ArticleManager.ArticleShortData;
import fishrungames.bashgid.core.ChannelManager.ChannelFullData;
import fishrungames.bashgid.core.DatabaseDownloadTask;
import fishrungames.bashgid.core.HtmlDownloadManager.TextFileRecord;
import fishrungames.bashgid.core.JournalManager.JournalSemiFullData;
import fishrungames.bashgid.core.NewsDownloadTask;

import fishrungames.bashgid.core.PhotoManager.PhotoRecordData;
import fishrungames.bashgid.core.VideoManager;
import fishrungames.bashgid.core.VideoManager.VideoRecordData;
import fishrungames.bashgid.core.db.AlbumDataSource;
import fishrungames.bashgid.core.db.ArticleDataSource;
import fishrungames.bashgid.core.db.BashgidSqliteHelper;
import fishrungames.bashgid.core.db.ChannelDataSource;
import fishrungames.bashgid.core.db.JournalDataSource;
import fishrungames.bashgid.core.db.NewsDataSource;
import fishrungames.bashgid.core.db.PhotoDataSource;
import fishrungames.bashgid.core.db.VideoDataSource;

import fishrungames.networkutils.ContextHolder;
import fishrungames.networkutils.ImageDownloadTask;
import fishrungames.networkutils.ImageManager;
import android.support.v7.app.ActionBarActivity;
import android.support.v4.app.Fragment;

import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;

import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;

import android.support.v4.widget.DrawerLayout;

public class MainActivity extends ActionBarActivity implements NavigationDrawerFragment.NavigationDrawerCallbacks
{

	public static final String TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT = "TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT";
	public static final String TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT = "TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT";
	public static final String TAG_FROM_SEARCHFRAGMENT_TO_NEWSRECORDFRAGMENT = "TAG_FROM_SEARCHFRAGMENT_TO_NEWSRECORDFRAGMENT";
	public static final String TAG_FROM_BOOKSFRAGMENT_TO_BOOKRECORDFRAGMENT = "TAG_FROM_BOOKSFRAGMENT_TO_BOOKRECORDFRAGMENT";
	public static final String TAG_FROM_VIDEOLISTFRAGMENT_TO_VIDEORECORDFRAGMENT = "TAG_FROM_VIDEOLISTFRAGMENT_TO_VIDEORECORDFRAGMENT";

	public static final String TAG_FROM_PHOTOLISTFRAGMENT_TO_PHOTOFRAGMENT = "TAG_FROM_PHOTOLISTFRAGMENT_TO_PHOTOFRAGMENT";
	public static final String TAG_FROM_ARTICLEFRAGMENT_TO_PHOTOFRAGMENT = "TAG_FROM_ARTICLEFRAGMENT_TO_PHOTOFRAGMENT";
	public static final String TAG_FROM_MAPFRAGMENT_TO_ARTICLEFRAGMENT = "TAG_FROM_MAPFRAGMENT_TO_ARTICLEFRAGMENT";

	public static final String TAG_FROM_CATALOGFRAGMENT_TO_ARTICLEFRAGMENT = "TAG_FROM_CATALOGFRAGMENT_TO_ARTICLEFRAGMENT";
	public static final String TAG_FROM_CATALOGFRAGMENT_TO_JOURNALFRAGMENT = "TAG_FROM_CATALOGFRAGMENT_TO_JOURNALFRAGMENT";

	
	
	
	
	public static final String TAG_TO_WELCOMEFRAGMENT = "WelcomeFragment";
	public static final String TAG_TO_SEARCHFRAGMENT = "SearchFragment";
	public static final String TAG_TO_MAINFRAGMENT = "MainFragment";
	public static final String TAG_TO_MAPFRAGMENT = "MapFragment";
	
	
	public static final String PREFS_MAIN = "PREFS_MAIN";

	public static final int NEWS_DOWNLOADER_STATE_UPDATE = 10;
	public static final int NEWS_DOWNLOADER_STATE_FINISHED = 11;
	
	public static final int DATABASE_DOWNLOADER_STATE_UPDATE = 12;
	public static final int DATABASE_DOWNLOADER_STATE_FINISHED = 13;
	
	public static final int DATABASE_GET_ALBUM_STATE_UPDATE = 14;
	public static final int DATABASE_GET_ALBUM_STATE_FINISHED = 15;
	
	public static final int DATABASE_GET_ALBUM_LIST_STATE_UPDATE = 16;
	public static final int DATABASE_GET_ALBUM_LIST_STATE_FINISHED = 17;
	
	public static final int DATABASE_GET_ARTICLE_STATE_UPDATE = 18;
	public static final int DATABASE_GET_ARTICLE_STATE_FINISHED = 19;
	
	public static final int DATABASE_GET_JOURNAL_STATE_UPDATE = 20;
	public static final int DATABASE_GET_JOURNAL_STATE_FINISHED = 21;
	
	public static final int DATABASE_GET_CHANNEL_STATE_UPDATE = 22;
	public static final int DATABASE_GET_CHANNEL_STATE_FINISHED = 23;
	
	public static final int DATABASE_GET_VIDEO_STATE_UPDATE = 24;
	public static final int DATABASE_GET_VIDEO_STATE_FINISHED = 25;
	
	public static final int DATABASE_GET_JOURNAL_LIST_STATE_UPDATE = 26;
	public static final int DATABASE_GET_JOURNAL_LIST_STATE_FINISHED = 27;
	
	public static final int DATABASE_SEARCH_ARTICLE_STATE_UPDATE = 28;
	public static final int DATABASE_SEARCH_ARTICLE_STATE_FINISHED = 29;
	
	
	

	MainPageFragment mainPageFragment = null;
	NewsListFragment newsListFragment = null;
	NewsRecordFragment newsRecordFragment = null;
	
	AlbumListFragment albumListFragment = null;
	PhotoAlbumFragment photoAlbumFragment = null;
	PhotoFragment photoFragment = null;
	
	ArticleFragment articleFragment = null;
	JournalFragment journalFragment = null;
	
	VideoListFragment videoListFragment = null;
	VideoRecordFragment videoRecordFragment = null;
	OsmMapHolderFragment mapHolderFragment = null;
	
	SearchFragment searchFragment = null;
	
	CatalogFragment catalogFragment = null;

	static MainActivity instance = null;

	private NavigationDrawerFragment mNavigationDrawerFragment = null;

	public BashgidSqliteHelper dbHelper = null;
	
	public NewsDataSource newsDataSource = null;
	public PhotoDataSource photoDataSource = null;
	public AlbumDataSource albumDataSource = null;
	public ArticleDataSource articleDataSource = null;

	public VideoDataSource videoDataSource = null;
	public ChannelDataSource channelDataSource = null;
	
	public JournalDataSource journalDataSource = null;
	
	public Handler mHandler;

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);

		ImageManager.getInstance().PredefinedImageId.put("R.drawable.no_picture", R.drawable.no_picture);
		
		setContentView(R.layout.activity_main);

		SetupDrawer();

		ImageManager.getInstance().alwaysUpdateImagesWithoutHash = false;

		getSupportFragmentManager().beginTransaction().add(R.id.fragment_container, new WelcomeFragment(), TAG_TO_WELCOMEFRAGMENT).commit();

		instance = this;
		ContextHolder.setContext(instance);
		
		dbHelper = new BashgidSqliteHelper(this);
		
		newsDataSource = new NewsDataSource(this, dbHelper);
		
		photoDataSource = new PhotoDataSource(this, dbHelper);

		albumDataSource = new AlbumDataSource(this, dbHelper);
		
		articleDataSource = new ArticleDataSource(this, dbHelper);
		
		videoDataSource = new VideoDataSource(this, dbHelper);
		
		channelDataSource = new ChannelDataSource(this, dbHelper);
		
		journalDataSource = new JournalDataSource(this, dbHelper);
		

		mHandler = new Handler(Looper.getMainLooper())
		{
			@Override
			public void handleMessage(Message inputMessage)
			{

				switch (inputMessage.what)
				{
				case ImageDownloadTask.IMAGE_DOWNLOADER_STATE_UPDATE:
				case ImageDownloadTask.IMAGE_DOWNLOADER_STATE_FINISHED:
					UpdateOnImageDownloaded();
					break;
				case NEWS_DOWNLOADER_STATE_UPDATE:
				case NEWS_DOWNLOADER_STATE_FINISHED:
					UpdateOnNewsDownloaded();
					break;
				case DATABASE_DOWNLOADER_STATE_UPDATE:
				case DATABASE_DOWNLOADER_STATE_FINISHED:
					UpdateOnDatabaseDownloaded();
					break;
				case DATABASE_GET_ALBUM_STATE_UPDATE:
				case DATABASE_GET_ALBUM_STATE_FINISHED:
					UpdateOnAlbumLoaded((AlbumFullData)inputMessage.obj);
					break;
				case DATABASE_GET_ALBUM_LIST_STATE_UPDATE:
				case DATABASE_GET_ALBUM_LIST_STATE_FINISHED:
					
					ArrayList<AlbumShortData> albumShortList = (ArrayList<AlbumShortData>) inputMessage.obj;
					
					UpdateOnAlbumListLoaded(albumShortList);
					break;
				case DATABASE_GET_ARTICLE_STATE_UPDATE:
				case DATABASE_GET_ARTICLE_STATE_FINISHED:
					UpdateOnArticleLoaded((ArticleFullData)inputMessage.obj);
					break;
				case DATABASE_GET_JOURNAL_STATE_UPDATE:
				case DATABASE_GET_JOURNAL_STATE_FINISHED:
					UpdateOnJournalLoaded((JournalSemiFullData)inputMessage.obj);
					break;
				case DATABASE_GET_CHANNEL_STATE_UPDATE:
				case DATABASE_GET_CHANNEL_STATE_FINISHED:
					UpdateOnChannelLoaded((ChannelFullData)inputMessage.obj);
					break;
					
				case DATABASE_GET_VIDEO_STATE_UPDATE:
				case DATABASE_GET_VIDEO_STATE_FINISHED:
					UpdateOnVideoLoaded((VideoRecordData)inputMessage.obj);
					break;
					
				case DATABASE_GET_JOURNAL_LIST_STATE_UPDATE:
				case DATABASE_GET_JOURNAL_LIST_STATE_FINISHED:
					UpdateOnJournalListLoaded((ArrayList<JournalSemiFullData>) inputMessage.obj);
					break;
					
					
				case DATABASE_SEARCH_ARTICLE_STATE_UPDATE:
				case DATABASE_SEARCH_ARTICLE_STATE_FINISHED:
					UpdateOnArticleSearchPerformed((ArrayList<ArticleShortData>) inputMessage.obj);
					break;

			
					
				default:
					super.handleMessage(inputMessage);
				}
			}

		};
		
		

		albumDataSource.CreateNewAlbum(new AlbumRecordData("TEST", "Vk Photos", "Wow"));
		
		
		Date articleTestDate = new Date();
		Date articleTestDate2 = new Date();
		
		try
		{
			articleTestDate = ArticleManager.iso8601Format.parse("2015-05-30 9:00:00");
			articleTestDate2 = ArticleManager.iso8601Format.parse("2015-05-30 9:30:00");
		} catch (ParseException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		AlbumManager.DownloadAndAddPhotoToAlbum(new PhotoRecordData(
				"Lilia",
				"Lilia photo",
				"http://pp.vk.me/c622725/v622725384/3290f/hfnoyPHe5y8.jpg",
				"",
				0,
				0), "TEST");

		
		AlbumManager.DownloadAndAddPhotoToAlbum(new PhotoRecordData(
				"Vlad 2",
				"Vlad's photo",
				"http://pp.vk.me/c623226/v623226718/2af84/NeEYYIlnR-I.jpg",
				"",
				0,
				0
				), "TEST");
		
		articleDataSource.CreateNewArticle(new ArticleRecordData(
				"TESTART",
				0,
				"Photos",
				"Wow 2 photos",
				54.779610,
				56.032101,
				"http://www.yandex.ru/",
				articleTestDate
				));
		
		articleDataSource.AddAlbumToArticle("TEST", "TESTART");
		
		//AlbumManager.AddExistingArticleToJournal("TESTART", "news");
		
		
		AlbumManager.AddExistingArticleToJournal("TESTART", "map");
		
		AlbumManager.AddExistingArticleToJournal("TESTART", "investor");
		
		AlbumManager.AddNewVideoToChannel(new VideoRecordData(
				VideoManager.VIDEO_TYPE_YOUTUBE,
				"http://www.youtube.com/watch?v=dQw4w9WgXcQ",
				"Rickroll",
				"Mega Rickroll",
				"http://img.youtube.com/vi/dQw4w9WgXcQ/0.jpg",
				""), "main");
		
		AlbumManager.AddNewArticleToJournal(new ArticleRecordData(
				"testArticle2",
				ArticleManager.ARTICLE_TYPE_NORMAL,
				"My article",
				"Wow content lol",
				0,
				0,
				"http://fishrungames.ru",
				articleTestDate2
				), "investor");
		
		//articleDataSource.AddAlbumToArticle("TEST", "testArticle2");
		//articleDataSource.AddChannelToArticle("main", "testArticle2");
		
		DownloadDatabase();
		
	}

	public static MainActivity getInstance()
	{
		return instance;

	}
	
	public void DownloadImageArr(String [] imageUrlArr)
	{

		Bundle innerQuery = new Bundle();
						
		innerQuery.putStringArray("imageUrlArr", imageUrlArr);

		ImageDownloadTask task = new ImageDownloadTask();

		task.mHandler = mHandler;

		task.execute(innerQuery);
	}
	
	public void DownloadImageArr(String [] imageUrlArr, String [] imageHashArr)
	{

		Bundle innerQuery = new Bundle();
						
		innerQuery.putStringArray("imageUrlArr", imageUrlArr);
		innerQuery.putStringArray("imageHashArr", imageHashArr);

		ImageDownloadTask task = new ImageDownloadTask();

		task.mHandler = mHandler;

		task.execute(innerQuery);
	}
	
	public void DownloadImage(String imageUrl)
	{
		this.DownloadImageArr(new String []{imageUrl});
	}
	
	public void DownloadImage(String imageUrl, String imageHash)
	{

		this.DownloadImageArr(new String []{imageUrl}, new String []{imageHash});
	}
	
	public void DownloadDatabase()
	{
		DatabaseDownloadTask task = new DatabaseDownloadTask();

		task.mHandler = mHandler;

		task.execute();
	}

	public void ClearAllFragmentLinks()
	{
		mainPageFragment = null;
		newsListFragment = null;
		newsRecordFragment = null;
		
		albumListFragment = null;
		photoAlbumFragment = null;
		photoFragment = null;
		
		articleFragment = null;
		journalFragment = null;
		
		videoListFragment = null;
		videoRecordFragment = null;
		mapHolderFragment = null;
		
		searchFragment = null;
		catalogFragment = null;
	}

	public void StartDownloadImagesTask(ArrayList<String> imageUrlArr, ArrayList<String> imageHashArr)
	{
		ImageDownloadTask task = new ImageDownloadTask();

		task.mHandler = mHandler;

		Bundle query = new Bundle();

		query.putStringArray("imageUrlArr", (String[]) imageUrlArr.toArray());

		task.execute(query);
	}
	
	public void StartDownloadNewsTask()
	{
		NewsDownloadTask task = new NewsDownloadTask();
		
		task.mHandler = mHandler;

		task.execute();
	}

	public void UpdateOnImageDownloaded()
	{
		if (mainPageFragment != null)
		{
			mainPageFragment.RefreshJournal();
		}
		
		if (newsListFragment != null)
		{
			newsListFragment.RefreshJournal();
		}
	}

	public void UpdateOnNewsDownloaded()
	{
		if (mainPageFragment != null)
		{
			mainPageFragment.RefreshJournal();
		}
		
		if (newsListFragment != null)
		{
			newsListFragment.RefreshJournal();
		}
	}
	
	public void UpdateOnDatabaseDownloaded()
	{
		
	}
	
	public void UpdateOnAlbumLoaded(AlbumFullData album)
	{ 
		if (photoFragment != null)
		{
			photoFragment.SetAlbum(album);
		}
		
		if (photoAlbumFragment != null)
		{
			photoAlbumFragment.SetAlbum(album);
		}
	}
	
	public void UpdateOnArticleLoaded(ArticleFullData article)
	{ 
		if (articleFragment != null)
		{
			articleFragment.SetArticle(article);
		}
		
		if (newsRecordFragment != null)
		{
			newsRecordFragment.SetArticle(article);
		}
		
		if (mapHolderFragment != null)
		{
			mapHolderFragment.SetArticle(article);
		}
	}
	
	public void UpdateOnAlbumListLoaded(ArrayList<AlbumShortData> albumList)
	{ 
		if (albumListFragment != null)
		{
			albumListFragment.SetAlbumList(albumList);
		}
	}
	
	
	public void UpdateOnJournalLoaded(JournalSemiFullData journal)
	{ 
		if (journalFragment != null)
		{
			journalFragment.SetJournal(journal);
		}
		
		if (newsListFragment != null)
		{
			newsListFragment.SetJournal(journal);
		}		
		
		if (mainPageFragment != null)
		{
			mainPageFragment.SetJournal(journal);
		}	
		
		if (mapHolderFragment != null)
		{
			mapHolderFragment.SetJournal(journal);
		}	
		
	}
	
	
	
	
	public void UpdateOnChannelLoaded(ChannelFullData channel)
	{ 
		
		if (videoListFragment != null)
		{
			videoListFragment.SetChannel(channel);
		}
	}
	
	
	public void UpdateOnVideoLoaded(VideoRecordData video)
	{ 
		
		if (videoRecordFragment != null)
		{
			videoRecordFragment.SetVideo(video);
		}
	}
	
	public void UpdateOnJournalListLoaded(ArrayList<JournalSemiFullData> journalList)
	{ 
		
		if (catalogFragment != null)
		{
			catalogFragment.SetJournalList(journalList);
		}
	}
	
	
	public void UpdateOnArticleSearchPerformed(ArrayList<ArticleShortData> articleArr)
	{ 
		
		if (searchFragment != null)
		{
			searchFragment.SetSearchResult(articleArr);
		}
	}
	
	
	public void OnSearchPressed()
	{
		if (searchFragment != null)
		{
			return;
		}
		
		if (newsListFragment != null || newsRecordFragment != null)
		{
			OpenSearchScreen("news", "News");
			return;
		}
		
		if (journalFragment != null)
		{
			if (journalFragment.journal == null)
			{
				OpenSearchScreen(journalFragment.journalName, "");
			}
			else
			{
				OpenSearchScreen(journalFragment.journalName, journalFragment.journal.title);
			}
			return;
		}
		
		OpenSearchScreen();
	}
	

	public void OnSelectEnglish(View view)
	{
		Locale.setDefault(Locale.US);
		Configuration config = new Configuration();
		config.locale = Locale.US;
		getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());

		getSupportActionBar().setTitle(R.string.app_name);

		SetupDrawer();

		OpenMainScreen();
	}

	public void OnSelectRussian(View view)
	{
		Locale locale = new Locale("ru");
		Locale.setDefault(locale);
		Configuration config = new Configuration();
		config.locale = locale;
		getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());

		getSupportActionBar().setTitle(R.string.app_name);
		SetupDrawer();

		OpenMainScreen();
	}

	public void OnSelectChinese(View view)
	{
		Locale.setDefault(Locale.CHINA);
		Configuration config = new Configuration();
		config.locale = Locale.CHINA;
		getBaseContext().getResources().updateConfiguration(config, getBaseContext().getResources().getDisplayMetrics());

		getSupportActionBar().setTitle(R.string.app_name);
		SetupDrawer();

		OpenMainScreen();
	}

	public void OnSelectSemiDetails(Integer pos)
	{
		// getSupportFragmentManager().beginTransaction().add(R.id.fragment_container,
		// new SemiDetailsFragment()).addToBackStack(null).commit();
	}

	public void OpenMainScreen()
	{
		ClearAllFragmentLinks();
		
		mainPageFragment = new MainPageFragment();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, mainPageFragment).commit();

		mNavigationDrawerFragment.EnableDrawer();
		
	}

	public void OpenNewsScreen()
	{
		
		ClearAllFragmentLinks();
		
		newsListFragment = new NewsListFragment();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, newsListFragment).commit();

		mNavigationDrawerFragment.EnableDrawer();
		
	}
	
	public void OpenCatalogScreen()
	{
		
		ClearAllFragmentLinks();
		
		catalogFragment = new CatalogFragment();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, catalogFragment).commit();

		mNavigationDrawerFragment.EnableDrawer();
		
	}
	
	public void OpenJournalScreen(String journalName, String tag)
	{

		ClearAllFragmentLinks();
	
		journalFragment = new JournalFragment(journalName);
		
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, journalFragment, tag).commit();
		
		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenSettingsScreen()
	{
		ClearAllFragmentLinks();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new SettingsFragment()).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenSearchScreen()
	{
		ClearAllFragmentLinks();
		
		searchFragment = new SearchFragment();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, searchFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	public void OpenSearchScreen(String journalName, String journalTitle)
	{
		ClearAllFragmentLinks();
		
		searchFragment = new SearchFragment(journalName, journalTitle);

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, searchFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	/*
	public void OpenSearchScreen()
	{
		ClearAllFragmentLinks();
		
		SearchFragment

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new SearchFragment(), TAG_TO_SEARCHFRAGMENT)
				.commit();

		mNavigationDrawerFragment.EnableDrawer();

	}*/

	public void OpenLinkContentScreen(TextFileRecord contentRecord)
	{
		ClearAllFragmentLinks();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new LinkContentFragment(contentRecord), TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenMapScreen(String filter)
	{
		ClearAllFragmentLinks();

		mapHolderFragment = new OsmMapHolderFragment(0, filter);
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, mapHolderFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	/*
	public void OpenMapScreenByArticleName(String articleName)
	{
		ClearAllFragmentLinks();

		mapHolderFragment = new OsmMapHolderFragment(1, articleName);
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, mapHolderFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}*/
	
	public void OpenMapScreen(ArticleFullData articleFullData)
	{
		ClearAllFragmentLinks();

		mapHolderFragment = new OsmMapHolderFragment(articleFullData);
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, mapHolderFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenStreetViewScreen(double lat, double lon)
	{
		ClearAllFragmentLinks();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new StreetViewHolderFragment(lat, lon), TAG_TO_MAPFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenPhotoAlbumListScreen()
	{
		ClearAllFragmentLinks();
		
		albumListFragment = new AlbumListFragment();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, albumListFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenPhotoAlbumScreen(String albumName)
	{
		ClearAllFragmentLinks();
		
		photoAlbumFragment = new PhotoAlbumFragment(albumName);

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, photoAlbumFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	
	public void OpenPhotoScreen(String albumName, int position, String tag)
	{
		ClearAllFragmentLinks();
		
		photoFragment = new PhotoFragment(albumName, position);

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, photoFragment, tag).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	public void OpenPhotoScreen(AlbumFullData album, int position, String tag)
	{
		ClearAllFragmentLinks();
		
		photoFragment = new PhotoFragment(album, position);

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, photoFragment, tag).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenNewsRecordScreen(String articleName, String tag)
	{
		// Xperimental -- addToBackStack provoke error "Class not found". Need
		// to resolve somehow!
		// getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container,
		// new NewsRecordFragment(newsRecord)).addToBackStack(null).commit();

		// I added workaround:

		ClearAllFragmentLinks();

		newsRecordFragment = new NewsRecordFragment(articleName);

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, newsRecordFragment, tag).commit();

		mNavigationDrawerFragment.EnableDrawer();

	}
	public void OpenArticleScreen(String articleName, String tag)
	{
		
		ClearAllFragmentLinks();
		
		articleFragment = new ArticleFragment(articleName);
		
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, articleFragment, tag).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	

	public void OpenHtmlViewerScreen(String url)
	{
		ClearAllFragmentLinks();

		HtmlViewerFragment htmlViewerFragment = new HtmlViewerFragment();
		htmlViewerFragment.url = url;
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, htmlViewerFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void OpenBooksScreen()
	{
		ClearAllFragmentLinks();

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new BooksFragment(), TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();

	}

	public void OpenBookRecordScreen(BookRecord bookRecord, String tag)
	{
		// Xperimental -- addToBackStack provoke error "Class not found". Need
		// to resolve somehow!
		// getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container,
		// new NewsRecordFragment(newsRecord)).addToBackStack(null).commit();

		// I added workaround:
		ClearAllFragmentLinks();

		BookRecordFragment bookRecordFragment = new BookRecordFragment(bookRecord);

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, bookRecordFragment, tag).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}
	
	public void OpenVideoListScreen(String channelName)
	{
		ClearAllFragmentLinks();

		videoListFragment = new VideoListFragment(channelName);
		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, videoListFragment, TAG_TO_MAINFRAGMENT).commit();

		mNavigationDrawerFragment.EnableDrawer();

	}

	public void OpenVideoRecordScreen(VideoRecordData video, String tag)
	{
		// Xperimental -- addToBackStack provoke error "Class not found". Need
		// to resolve somehow!
		// getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container,
		// new NewsRecordFragment(newsRecord)).addToBackStack(null).commit();

		// I added workaround:

		ClearAllFragmentLinks();

		videoRecordFragment = new VideoRecordFragment(video);

		getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, videoRecordFragment, tag).commit();

		mNavigationDrawerFragment.EnableDrawer();
	}

	public void UpdateMainScreenIfPossible(Bundle result)
	{
		if (mainPageFragment != null)
		{
			mainPageFragment.RefreshJournal();
		}
	}
	

	@Override
	public void onAttachFragment(Fragment fragment)
	{
		super.onAttachFragment(fragment);

	}

	public void SetupDrawer()
	{

		mNavigationDrawerFragment = (NavigationDrawerFragment) getSupportFragmentManager().findFragmentById(R.id.navigation_drawer);

		if (mNavigationDrawerFragment != null)
		{

			// Set up the drawer.
			mNavigationDrawerFragment.setUp(R.id.navigation_drawer, (DrawerLayout) findViewById(R.id.drawer_layout));
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{

		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.global, menu);
		return super.onCreateOptionsMenu(menu);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item)
	{
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();

		if (id == R.id.action_search)
		{
			OnSearchPressed();
			return true;
		}

		if (id == R.id.action_settings)
		{
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	@Override
	public void onNavigationDrawerItemSelected(int position)
	{
		if (position == 1)
		{
			OpenMainScreen();
		} else if (position == 2)
		{
			OpenNewsScreen();
			
		}
		else if (position == 3)
		{
			OpenCatalogScreen();
		} else if (position == 4)
		{
			OpenMapScreen("map");
		} else if (position == 5)
		{
			OpenVideoListScreen("main");
		} else if (position == 6)
		{
			OpenPhotoAlbumListScreen();			
		}
		else if (position == 7)
		{
			OpenBooksScreen();
		}
		else if (position == 8)
		{
			OpenJournalScreen("investor", MainActivity.TAG_TO_MAINFRAGMENT);
		}
		else if (position == 9)
		{
			OpenSettingsScreen();
		}
	}

	@Override
	public void onBackPressed()
	{

		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT) != null)
		{
			OpenMainScreen();

			return;
		}

		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_NEWSLISTFRAGMENT_TO_NEWSRECORDFRAGMENT) != null)
		{
			OpenNewsScreen();

			return;
		}

		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_BOOKSFRAGMENT_TO_BOOKRECORDFRAGMENT) != null)
		{
			OpenBooksScreen();

			return;
		}

		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_VIDEOLISTFRAGMENT_TO_VIDEORECORDFRAGMENT) != null)
		{
			OpenVideoListScreen("main");

			return;
		}

		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_SEARCHFRAGMENT_TO_NEWSRECORDFRAGMENT) != null)
		{
			OpenSearchScreen();

			return;
		}
		
		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_PHOTOLISTFRAGMENT_TO_PHOTOFRAGMENT) != null)
		{
			OpenPhotoAlbumScreen(GetLastAlbumName());
			return;
		}
		
		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_ARTICLEFRAGMENT_TO_PHOTOFRAGMENT) != null)
		{
			OpenArticleScreen(GetLastArticleName(), TAG_TO_MAINFRAGMENT);
			return;
		}
		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_MAPFRAGMENT_TO_ARTICLEFRAGMENT) != null)
		{
			OpenMapScreen(GetLastMapFilterName());
			return;
		}
		
		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_CATALOGFRAGMENT_TO_ARTICLEFRAGMENT) != null)
		{
			OpenCatalogScreen();

			return;
		}
		
		if (getSupportFragmentManager().findFragmentByTag(TAG_FROM_CATALOGFRAGMENT_TO_JOURNALFRAGMENT) != null)
		{
			OpenCatalogScreen();

			return;
		}

		
		if (getSupportFragmentManager().findFragmentByTag(TAG_TO_SEARCHFRAGMENT) != null)
		{
			OpenMainScreen();

			return;
		}

		if (getSupportFragmentManager().findFragmentByTag(TAG_TO_MAINFRAGMENT) != null)
		{
			OpenMainScreen();

			return;
		}
		
		

		if (getSupportFragmentManager().findFragmentByTag(TAG_TO_MAPFRAGMENT) != null)
		{
			OpenMapScreen("map");

			return;
		}

		super.onBackPressed();

		/*
		 * AddToBackStack is falling. Here is workaround
		 * if(getSupportFragmentManager().getBackStackEntryCount() != 0) {
		 * getSupportFragmentManager().popBackStack(); } else {
		 * super.onBackPressed(); }
		 */
	}
	
	public void SetLastAlbumName(String lastAlbumName)
	{
		SharedPreferences settings = MainActivity.getInstance().getSharedPreferences(PREFS_MAIN, 0);

		SharedPreferences.Editor editor = settings.edit();
		editor.putString("lastAlbumName", lastAlbumName);
		editor.commit();
	}
	
	public String GetLastAlbumName()
	{
		SharedPreferences settings = MainActivity.getInstance().getSharedPreferences(PREFS_MAIN, 0);
		return settings.getString("lastAlbumName", "");
	}
	
	public void SetLastArticleName(String lastArticleName)
	{
		SharedPreferences settings = MainActivity.getInstance().getSharedPreferences(PREFS_MAIN, 0);

		SharedPreferences.Editor editor = settings.edit();
		editor.putString("lastArticleName", lastArticleName);
		editor.commit();
	}
	
	public String GetLastArticleName()
	{
		SharedPreferences settings = MainActivity.getInstance().getSharedPreferences(PREFS_MAIN, 0);
		return settings.getString("lastArticleName", "");
	}
	
	public void SetLastMapFilterName(String lastMapFilterName)
	{
		SharedPreferences settings = MainActivity.getInstance().getSharedPreferences(PREFS_MAIN, 0);

		SharedPreferences.Editor editor = settings.edit();
		editor.putString("lastMapFilterName", lastMapFilterName);
		editor.commit();
	}
	
	public String GetLastMapFilterName()
	{
		SharedPreferences settings = MainActivity.getInstance().getSharedPreferences(PREFS_MAIN, 0);
		return settings.getString("lastMapFilterName", "");
	}

	@Override
	protected void onResume()
	{

		super.onResume();
	}

	@Override
	protected void onPause()
	{
		super.onPause();
	}


}
