package fishrungames.bashgid.core;


import java.util.ArrayList;

import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;

import fishrungames.bashgid.MainActivity;
import fishrungames.bashgid.core.ArticleManager.ArticleShortData;
import fishrungames.bashgid.core.JournalManager.JournalSemiFullData;

public class DatabaseSearchArticleTask extends AsyncTask<Bundle, Integer, Long>
{

	public Handler mHandler;
	
	ArrayList<ArticleShortData> articleArr = new ArrayList<ArticleShortData>();

	protected Long doInBackground(Bundle... queryArr)
	{
		String query = queryArr[0].getString("query");
		
		String journalName = queryArr[0].getString("journalName");
		
		
		if (journalName != null && journalName.length() > 0)
		{
			articleArr = MainActivity.getInstance().articleDataSource.SearchArticleByQueryAndJournal(query, journalName);
		}
		else
		{
			articleArr = MainActivity.getInstance().articleDataSource.SearchArticleByQuery(query);
			
		}
		
		//articleArr.addAll(journal.articleArr);
		
		return (long) 0;
	}

	protected void onProgressUpdate(Integer... progress)
	{
		Message completeMessage = mHandler.obtainMessage(MainActivity.DATABASE_SEARCH_ARTICLE_STATE_UPDATE, articleArr);

		completeMessage.sendToTarget();

	}

	protected void onPostExecute(Long result)
	{
		Message completeMessage = mHandler.obtainMessage(MainActivity.DATABASE_SEARCH_ARTICLE_STATE_FINISHED, articleArr);

		completeMessage.sendToTarget();
	}
	

}